/*
 *   Copyright (c) 2009, Michael Lehn
 *
 *   All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1) Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2) Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in
 *      the documentation and/or other materials provided with the
 *      distribution.
 *   3) Neither the name of the FLENS development group nor the names of
 *      its contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef CXXBLAS_CXXBLAS_TCC
#define CXXBLAS_CXXBLAS_TCC 1

#ifdef CXXBLAS_DEBUG
#   ifndef CXXBLAS_DEBUG_OUT
#   define CXXBLAS_DEBUG_OUT(msg)   std::cerr << msg << std::endl
#   endif // CXXBLAS_DEBUG_OUT
#endif // CXXBLAS_DEBUG_OUT

#ifndef CXXBLAS_DEBUG_OUT
#define CXXBLAS_DEBUG_OUT(msg)
#endif // CXXBLAS_DEBUG_OUT

#include <cxxblas/auxiliary/complex.tcc>
#include <cxxblas/drivers/drivers.tcc>

#include <cxxblas/level1/level1.tcc>
#include <cxxblas/level1extensions/level1extensions.tcc>
#include <cxxblas/level2/level2.tcc>
#include <cxxblas/level2extensions/level2extensions.tcc>
#include <cxxblas/level3/level3.tcc>

#include <cxxblas/sparselevel2/sparselevel2.tcc>

#endif // CXXBLAS_CXXBLAS_TCC
