/*
 *   Copyright (c) 2010, Michael Lehn
 *
 *   All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1) Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2) Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in
 *      the documentation and/or other materials provided with the
 *      distribution.
 *   3) Neither the name of the FLENS development group nor the names of
 *      its contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef FLENS_AUXILIARY_AUXILIARY_H
#define FLENS_AUXILIARY_AUXILIARY_H 1

#include <flens/auxiliary/constref.h>
#include <flens/auxiliary/compatiblescalar.h>
#include <flens/auxiliary/complextrait.h>
#include <flens/auxiliary/explicit_cast.h>
#include <flens/auxiliary/ifelseif.h>
#include <flens/auxiliary/indextype.h>
#include <flens/auxiliary/isclosure.h>
#include <flens/auxiliary/iscomplex.h>
#include <flens/auxiliary/isconvertible.h>
#include <flens/auxiliary/isgeneralmatrix.h>
#include <flens/auxiliary/ishermitianmatrix.h>
#include <flens/auxiliary/isinteger.h>
#include <flens/auxiliary/ismatrix.h>
#include <flens/auxiliary/ismatrixclosure.h>
#include <flens/auxiliary/isreal.h>
#include <flens/auxiliary/issame.h>
#include <flens/auxiliary/issymmetricmatrix.h>
#include <flens/auxiliary/istriangularmatrix.h>
#include <flens/auxiliary/isvector.h>
#include <flens/auxiliary/isvectorclosure.h>
#include <flens/auxiliary/macros.h>
#include <flens/auxiliary/max.h>
#include <flens/auxiliary/min.h>
#include <flens/auxiliary/noview.h>
#include <flens/auxiliary/pair.h>
#include <flens/auxiliary/promotion.h>
#include <flens/auxiliary/quadruple.h>
#include <flens/auxiliary/range.h>
#include <flens/auxiliary/removeref.h>
#include <flens/auxiliary/restrictto.h>
#include <flens/auxiliary/triple.h>
#include <flens/auxiliary/underscore.h>

#endif // FLENS_AUXILIARY_AUXILIARY_H
