/*
 *   Copyright (c) 2011, Michael Lehn
 *
 *   All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1) Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2) Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in
 *      the documentation and/or other materials provided with the
 *      distribution.
 *   3) Neither the name of the FLENS development group nor the names of
 *      its contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#if defined(QD_API) && !defined(FLENS_HACKS_QD_TCC)
#define FLENS_HACKS_QD_TCC 1

namespace std {

//
// signbit
//

int
signbit(const dd_real &x)
{
    return std::signbit(x.x[0]);
}

int
signbit(const qd_real &x)
{
    return std::signbit(x.x[0]);
}

} // namespace std


namespace flens {

//
// dd_real explicit_cast
//

template <>
int
explicit_cast(const dd_real &from)
{
    return to_int(from);
}

template <>
double
explicit_cast(const dd_real &from)
{
    return to_double(from);
}

//
// qd_real explicit_cast
//

template <>
int
explicit_cast(const qd_real &from)
{
    return to_int(from);
}

template <>
double
explicit_cast(const qd_real &from)
{
    return to_double(from);
}

template <>
dd_real
explicit_cast(const qd_real &from)
{
    return to_dd_real(from);
}

} // namespace flens

#endif // defined(QD_API) && !defined(FLENS_HACKS_QD_TCC)
